// Persistence of Vision Ray Tracer Scene Description File
// File: ?.pov
// Vers: 3.6
// Desc: Image Map Example
// Date: mm/dd/yy
// Auth: ?
//                            
                          

#version 3.6;

#include "metals.inc"                          
#include "math.inc"
#include "colors.inc"

#declare show_x=true; 
#declare show_x_e_whiskers = false;
#declare show_x_h_whiskers = false;

#declare show_y=true;
#declare show_y_e_whiskers = false;
#declare show_y_h_whiskers = false;

#declare show_z1=true;
#declare show_z1_e_whiskers = false;
#declare show_z1_h_whiskers = false;

#declare show_z2=true;               
#declare show_z2_e_whiskers = false;
#declare show_z2_h_whiskers = false;

#declare show_z3=true;
#declare show_z3_e_whiskers = false;
#declare show_z3_h_whiskers = false;

#declare show_frame_id=true;

#declare object_location=<0,2,0>;                                                

#declare base_filename = "C:\\data\\EMDrive\\CE3-copper-64cycles-2015-11-13\\CE3-copper-64cycles\\csv-directory\\"
                                                             

#declare local_clock = clock;
                                   

#declare image_num=(mod(local_clock,10));
//#declare image_num=(mod(2,14));
                        
#declare epsilon = 1e-6;
                                   
#declare object_rotation=<0,-local_clock/10,0>;



#declare e_thickness = 1;  // thickness for whiskers (e might not be used...)
#declare h_thickness = 0.002;                
#declare e_len_scale =1;    // length for whiskers E
#declare h_len_scale = 0.25; //                     H                         

                                                             
#if( show_x )
//generated include files are named like: 00-e_fields_X.inc
#declare e_x_inc_filename = concat(base_filename, str(image_num,-2,0),"-e_fields_x.inc")
#include e_x_inc_filename  
#declare e_x_vector = csv_vector;
#declare e_x_width = max_cols;
#declare e_x_length = max_rows;
#declare e_x_width_scale = (1.0/e_x_width);
#declare e_x_length_scale = (1.0/e_x_length);
#end

#if( show_y )
#declare e_y_inc_filename = concat(base_filename, str(image_num,-2,0),"-e_fields_y.inc")
#include e_y_inc_filename  
#declare e_y_vector = csv_vector;
#declare e_y_width = max_cols;
#declare e_y_length = max_rows;
#declare e_y_width_scale = (1.0/e_y_width);
#declare e_y_length_scale = (1.0/e_y_length);
#end
    
#if( show_z1 )
#declare e_z1_inc_filename = concat(base_filename, str(image_num,-2,0),"-e_fields_z1.inc")
#include e_z1_inc_filename  
#declare e_z1_vector = csv_vector;
#declare e_z1_width = max_cols;
#declare e_z1_length = max_rows;
#declare e_z1_width_scale = (1.0/e_z1_width);
#declare e_z1_length_scale = (1.0/e_z1_length);
#end
     
#if( show_z2 )
#declare e_z2_inc_filename = concat(base_filename, str(image_num,-2,0),"-e_fields_z2.inc")
#include e_z2_inc_filename  
#declare e_z2_vector = csv_vector;
#declare e_z2_width = max_cols;
#declare e_z2_length = max_rows;
#declare e_z2_width_scale = (1.0/e_z2_width);
#declare e_z2_length_scale = (1.0/e_z2_length);
#end
    
#if( show_z3 )
#declare e_z3_inc_filename = concat(base_filename, str(image_num,-2,0),"-e_fields_z3.inc")
#include e_z3_inc_filename  
#declare e_z3_vector = csv_vector;
#declare e_z3_width = max_cols;
#declare e_z3_length = max_rows;
#declare e_z3_width_scale = (1.0/e_z3_width);
#declare e_z3_length_scale = (1.0/e_z3_length);
#end
    
#if( show_x )    
#declare h_x_inc_filename = concat(base_filename, str(image_num,-2,0),"-h_fields_x.inc")
#include h_x_inc_filename  
#declare h_x_vector = csv_vector;
#declare h_x_width = max_cols;
#declare h_x_length = max_rows;
#declare h_x_width_scale = (1.0/h_x_width);
#declare h_x_length_scale = (1.0/h_x_length);
#end
    
#if( show_y )
#declare h_y_inc_filename = concat(base_filename, str(image_num,-2,0),"-h_fields_y.inc")
#include h_y_inc_filename  
#declare h_y_vector = csv_vector;
#declare h_y_width = max_cols;
#declare h_y_length = max_rows;
#declare h_y_width_scale = (1.0/h_y_width);
#declare h_y_length_scale = (1.0/h_y_length);
#end              
    
#if( show_z1 )
#declare h_z1_inc_filename = concat(base_filename, str(image_num,-2,0),"-h_fields_z1.inc")
#include h_z1_inc_filename  
#declare h_z1_vector = csv_vector;
#declare h_z1_width = max_cols;
#declare h_z1_length = max_rows;
#declare h_z1_width_scale = (1.0/h_z1_width);
#declare h_z1_length_scale = (1.0/h_z1_length);
#end
    
#if( show_z2 )
#declare h_z2_inc_filename = concat(base_filename, str(image_num,-2,0),"-h_fields_z2.inc")
#include h_z2_inc_filename  
#declare h_z2_vector = csv_vector;
#declare h_z2_width = max_cols;
#declare h_z2_length = max_rows;
#declare h_z2_width_scale = (1.0/h_z2_width);
#declare h_z2_length_scale = (1.0/h_z2_length);
#end

#if( show_z3 )
#declare h_z3_inc_filename = concat(base_filename, str(image_num,-2,0),"-h_fields_z3.inc")
#include h_z3_inc_filename  
#declare h_z3_vector = csv_vector;
#declare h_z3_width = max_cols;
#declare h_z3_length = max_rows;
#declare h_z3_width_scale = (1.0/h_z3_width);
#declare h_z3_length_scale = (1.0/h_z3_length);
#end

global_settings {
  assumed_gamma 1.0
}

// ----------------------------------------

camera {
  location  <3.0-(local_clock/100), 3.0, -2.0>
  direction z*2.5
  right     x*image_width/image_height
  look_at  object_location-(y/2)
}

sky_sphere {
  pigment {
    gradient y
    color_map {
      [0.0 color (Blue+(White/2))]
      [1.0 color White/2]
    }
  }
}

light_source {
  <0, 0, 0>            // light's position (translated below)
  color rgb <1, 1, 1>  // light's color
  translate <-30, 30, 0>
}

// ----------------------------------------

plane {
  y, -1
  texture {
    pigment { color Green/4+White/2 }
//  pigment {
//    julia <0.353, 0.288>, 30
//    interior 1, 1
//    color_map { 
//      [0 rgb 0]
//      [0.2 rgb x]
//      [0.4 rgb x+y]
//      [1 rgb 1]
//      [1 rgb 0]
//      }
//    scale 10
//   }
    finish { reflection 0.1 }
  }
}
                               

#macro one_slice( length_param, width_param, w_scale, l_scale, evec, hvec, show_whiskers )
#for (row,0,length_param-1,10)
    #for (col,0,width_param-1,10)               
        // e vector
        #local cyl_bot = <0,col*w_scale,row*l_scale>;
        #local cyl_top = cyl_bot + (evec[row][col]*e_len_scale/2);
        #if( vlength(evec[row][col]) > epsilon ) 
            #if( show_whiskers )
                cylinder 
                    {
                    cyl_bot, cyl_top, e_thickness
                    texture
                        {           
                        #if( cyl_top.x > 0 )
                            pigment { color Red * vlength(evec[row][col])*2 }
                        #else
                            pigment { color Blue * vlength(evec[row][col])*2  }
                        #end // color
                        finish  { phong 0.5 reflection{ 0.00 metallic 0.00} } 
                        } // texture
                    } // cylinder
            #else // no whiskers
                cylinder 
                    {
                    cyl_bot, cyl_bot+<0.001,0,0>, (l_scale+w_scale)/2*3
                    texture
                        {           
                        #if( cyl_top.x > 0 )
                            pigment { color rgbft<1*vlength(evec[row][col]), 0, 0, 1, .3>   }
                        #else
                            pigment { color rgbft<0, 0 1*vlength(evec[row][col]), 1, .3> }
                        #end // color
                        finish  { phong 0.5 reflection{ 0.00 metallic 0.00} } 
                        } // texture
                    } // cylinder
                
            #end
        #else // val < epsilon, just show dot
            cylinder 
                {
                cyl_bot, cyl_bot+<0.001,0,0>, w_scale/2 
                texture
                    {           
                    pigment { color Black }
                    finish  { phong 0.5 reflection{ 0.00 metallic 0.00} } 
                    } // texture
                } // cylinder
        #end // if epsilon e vector

        // h vector
        #declare cyl_bot = <0,col*w_scale,row*l_scale>;
        #declare cyl_top = cyl_bot + (hvec[row][col]*h_len_scale);
        #if( vlength(hvec[row][col]) > epsilon ) 
            cylinder 
                {
                cyl_bot, cyl_top, h_thickness
                texture
                    {           
                    #if( cyl_top.z > 0 )
                        pigment { color Green * vlength(hvec[row][col])  }
                    #else
                        pigment { color Yellow * vlength(hvec[row][col])  }
                    #end // color
                    finish  { phong 0.5 reflection{ 0.00 metallic 0.00} } 
                    } // texture
                } // cylinder
        // no else clause here, don't need another 'null' dot, one was already output from the E field.
        #end // if epsilon h vector

    #end // col
#end // row      
#end // macro


        
#if (show_x)                   
// horizontal slice
union 
{
    one_slice( e_x_length, e_x_width, e_x_width_scale, e_x_length_scale, e_x_vector, h_x_vector, show_x_e_whiskers )

    rotate z*90
    no_shadow
    
    translate object_location+<0.5,-0.5,0>
    rotate z*180                              
    rotate x*180
    rotate object_rotation
}
#end

#if (show_y)  
// horizontal slice
union 
{
    one_slice( e_y_length, e_y_width, e_y_width_scale, e_y_length_scale, e_y_vector, h_y_vector, show_y_e_whiskers )

    rotate z*90
    rotate x*90
    no_shadow
    
    translate object_location+<0.5,0,0.5>// center on the origin
    rotate z*180                              
    rotate x*180
    rotate object_rotation
}   
#end

#if (show_z1)
// horizontal slice
union 
{
    one_slice( e_z1_length, e_z1_width, e_z1_width_scale, e_z1_length_scale, e_z1_vector, h_z1_vector, show_z1_e_whiskers )
                    
    rotate z*90
    rotate x*90
    no_shadow
    
    translate object_location+<0.03,-.055,0.5>// center on the origin
    rotate z*180                              
    rotate x*180
    rotate y*90
    
    rotate object_rotation
}
#end

#if (show_z2)
// horizontal slice
union 
{
    one_slice( e_z2_length, e_z2_width, e_z2_width_scale, e_z2_length_scale, e_z2_vector, h_z2_vector, show_z2_e_whiskers )
                    
    rotate z*90
    rotate x*90
    no_shadow
    
    translate object_location+<0,0,0.2>// center on the origin
    rotate z*180                              
    rotate x*180
    rotate y*90
    
    rotate object_rotation
}
#end

#if (show_z3)
// horizontal slice
union 
{
    one_slice( e_z3_length, e_z3_width, e_z3_width_scale, e_z3_length_scale, e_z3_vector, h_z3_vector, show_z3_e_whiskers )
                    
    rotate z*90
    rotate x*90
    no_shadow
    
    translate object_location+<0,0.01,-.4>// center on the origin
    rotate z*180                              
    rotate x*180
    rotate y*90
    
    rotate object_rotation
}
#end

          
#if (show_frame_id)

text 
    { 
    ttf "arial.ttf", str(image_num,-1,0), 0.1, 0.12 // thickness, offset
    texture
        { 
        T_Chrome_4C
        finish{reflection 0.1}
        } // end of texture
    scale 0.5 
    translate object_location+<1,-.5,0>
    }

    
#end